Bug 1027651 - Wireless driver for Broadcom BCM4352 802.11 Hybrid Wireless Controller 6.30.223.95
Wireless driver for Broadcom BCM4352 802.11 Hybrid Wireless Controller 6.30.2...
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: fedora-kernel-wireless-brcm80211
Fedora Extras Quality Assurance
: FutureFeature, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-07 04:04 EST by Victor Ion Munteanu
Modified: 2014-03-19 09:42 EDT (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-19 09:42:02 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
lspci output (32.81 KB, text/plain)
2013-11-11 13:00 EST, Victor Ion Munteanu
no flags Details
udevadm output (3.51 KB, text/plain)
2013-11-13 13:23 EST, Victor Ion Munteanu
no flags Details
udevadm output #2 (441 bytes, text/plain)
2013-11-13 14:51 EST, Victor Ion Munteanu
no flags Details
Kernel config file (128.26 KB, text/plain)
2013-11-15 14:03 EST, Victor Ion Munteanu
no flags Details

  None (edit)
Description Victor Ion Munteanu 2013-11-07 04:04:22 EST
Description of problem:
I own a G750JX and the model comes with a Broadcom BCM43b1 802.11 Hybrid Wireless Controller 6.30.223.95

The fedora linux kernel does not come with a wireless driver for this card, however some people have made one that works.

It can be found here:
http://people.canonical.com/~ypwong/drivers/broadcom/hybrid-v35_64-nodebug-pcoem-6_30_223_95.tar.gz

For kernels >= 3.10 some adjustments need to be done (minor change in architecture). I can attach the updated version I use (manually compiled each kernel update).

Unfortunately, I'm not sure what needs to be done in order to push this module into the kernel but this module works (mostly) with minor hickups.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Start Fedora
2.
3.

Actual results:
No wifi

Expected results:
Wifi

Additional info:
Please see description
Comment 1 Josh Boyer 2013-11-07 08:20:18 EST
Fedora doesn't use out-of-tree drivers.  The best solution is to engage upstream in getting support for this device added to brcm80211.
Comment 2 Victor Ion Munteanu 2013-11-08 13:04:02 EST
Can you please give me some pointers on how to do that? Which person to contact, etc?
Comment 3 Arend van Spriel 2013-11-08 13:18:09 EST
You could look at: http://wireless.kernel.org/en/users/Drivers/brcm80211

When you do please recheck the device number, because there exists no such thing as a bcm43b1 chip.
Comment 4 Victor Ion Munteanu 2013-11-08 13:32:02 EST
I appologise, I was looking at dmesg messages instead of lspci. The correct model is

03:00.0 Network controller: Broadcom Corporation BCM4352 802.11ac Wireless Network Adapter (rev 03)
Comment 5 John Greene 2013-11-11 11:30:58 EST
Can you post lspci -nnvv of this?
I'll assume it's 0x14e4:4352, but would like to see more.  

Currently the upstream code supports *80211 cores* 17, 23,24.
Arend: the page you reference, doens't show 4352.  What would core id be for this?
I know you can get it with udevadm monitor, is this another tool for finding that core id?
Comment 6 Victor Ion Munteanu 2013-11-11 13:00:11 EST
Created attachment 822512 [details]
lspci output
Comment 7 Victor Ion Munteanu 2013-11-11 13:06:13 EST
According to the lspci output it's actually:

03:00.0 Network controller [0280]: Broadcom Corporation BCM4352 802.11ac Wireless Network Adapter [14e4:43b1] (rev 03)

I can run udevadm monitor but I need parameters for it (i ran it by itself and no output).
Comment 8 John Greene 2013-11-13 11:08:58 EST
Worked for me:
udevadm monitor --kernel --property
Comment 9 Victor Ion Munteanu 2013-11-13 13:23:02 EST
Created attachment 823595 [details]
udevadm output

Ok, I ran that command as root and the rmmod / modprobe to actually get something there. The output is attached.
Comment 10 John Greene 2013-11-13 14:14:35 EST
Better, but one more piece I missed.  
modprobe -r wl bcma brcmsmac

Setup the udev window as before
then do this instead
modprobe bcma

As noted in Comment 1 by the maintainers, we don't support out of tree drivers.  The wl driver you are using being one of them.  If we can get the ID of your core, perhaps it exists upstream in bcm80211 already. Saddly if not, ... I'd have to close this at that point.
Comment 11 Victor Ion Munteanu 2013-11-13 14:51:07 EST
Created attachment 823625 [details]
udevadm output #2

This is the requested output.
Comment 12 Victor Ion Munteanu 2013-11-13 14:56:43 EST
In case it's not upstream, can you at least point me in the right direction so that I may contact someone who is actually working on this and can help me?
Comment 13 Victor Ion Munteanu 2013-11-13 15:09:21 EST
Additionally, I found this:

http://git.kernel.org/cgit/linux/kernel/git/linville/wireless-testing.git/commit/?id=d4988d4c733ba0b61cb372edd3d1992d26dd10d3

Unfortunately I'm not familiar with the sumission workflow so I don't know when this patch (which supposedly adds support for my card) will get in the kernel.
Comment 14 John Greene 2013-11-15 10:13:59 EST
Munteanu,

The patch you mention appears to be in already, kernel version v3.9-12346-gd4988d4.  

The udev output seems to show the bcma isn't happy with your chip, doesn't find a core it supports, as you say. 

This device is an 802.11 ac device which I'm new to: this is newer high performance device and it makes sense that the drivers lag for this at this point. Let me check around.

Are you loading wl intentionally? (blacklisting b43 and or bcma/brcmsmac)

Can you post your kernel .config file?  Should be in the /boot directory with the kernel.
Comment 15 Victor Ion Munteanu 2013-11-15 14:03:28 EST
Created attachment 824657 [details]
Kernel config file
Comment 16 Victor Ion Munteanu 2013-11-15 14:15:47 EST
So, every time the kernel updates I recompile the kernel driver I pointed in the initial link (make clean, make, make install, depmod -a, modprobe wl). After doing this, any subsequent bootups with this kernel have wireless out of the box.

I do not blacklist b43 or bcma/brcmsmac.

Apparently, the driver done by the guy @canonical is based on the official broadcom driver (which now supports my card but doesn't compile):
http://www.broadcom.com/support/802.11/linux_sta.php
Comment 17 John Greene 2014-01-30 09:39:11 EST
(In reply to Munteanu Victor Ion from comment #13)
> Additionally, I found this:
> 
> http://git.kernel.org/cgit/linux/kernel/git/linville/wireless-testing.git/
> commit/?id=d4988d4c733ba0b61cb372edd3d1992d26dd10d3
> 
> Unfortunately I'm not familiar with the sumission workflow so I don't know
> when this patch (which supposedly adds support for my card) will get in the
> kernel.

This is in post 3.10 kernel already.
Comment 18 Victor Ion Munteanu 2014-01-30 10:15:47 EST
Then it's not working for my wifi (on 3.12.8-300.fc20.x86_64).
Comment 19 John Greene 2014-03-18 09:20:17 EDT
Munteanu, 

Probably not much help to you other than just peripheral info.  It appears that drivers are just now starting to support 802.11ac rates you desire.  The bug below is for an Intel chipset
https://bugzilla.redhat.com/show_bug.cgi?id=1076731

I just checked this morning for you again after reading it, nothing new to this issue for you from BCM upstream, unfortunately.  I'll keep looking, but until something shows up, not much I can do to help.

I know BCM is limited in resources to support open source, several chips we'd like to see support for already, but it's up to them to put resources on that effort.  Wish I had better news.

Would you like to keep this open still?
Comment 20 John Greene 2014-03-18 09:22:17 EDT
Forgot something.. The bz above shows *some* support for this technology in 3.14 which may or may not help, but is another build to try that can conceivably support you, but I'm pretty dubious without more support from the chip driver.

In all your spare time, right?  :)
Comment 21 Victor Ion Munteanu 2014-03-18 14:36:20 EDT
Dear John,

I don't know how to reply to your message. From my point of view as a regular linux user it is frustrating to see that you have a WORKING DRIVER and you refuze to accept it and integrate it in the linux kernel.

You said that:

> I know BCM is limited in resources to support open source, several chips we'd > like to see support for already, but it's up to them to put resources on that > effort.

The thing is Broadcom did they part. If you go to this link:
http://www.broadcom.com/support/802.11/linux_sta.php

and download the driver and compile it, it works (for kernel < 3.10) and for 3.10+ you need to do minor changes which I was able to do with some C knowledge and Google.

So, the there are two directions I can go. Wait like 1-2 years until more laptops come with this technology and support will be added at some point, or you can put me in contact with the person in charge of this specific module so that I may email him/her for information and I will brush off my C skills and integrate it myself, and then there's no excuse not to push it upstream.
Comment 22 Arend van Spriel 2014-03-18 17:15:36 EDT
(In reply to Munteanu Victor Ion from comment #21)
> Dear John,
> 
> I don't know how to reply to your message. From my point of view as a
> regular linux user it is frustrating to see that you have a WORKING DRIVER
> and you refuze to accept it and integrate it in the linux kernel.
> 
> You said that:
> 
> > I know BCM is limited in resources to support open source, several chips we'd > like to see support for already, but it's up to them to put resources on that > effort.
> 
> The thing is Broadcom did they part. If you go to this link:
> http://www.broadcom.com/support/802.11/linux_sta.php

I have to correct you here. This so-called hybrid driver that you indicate as working driver is only partially compiled and the majority is a binary blob. That is all the excuse one need to not push it upstream.
Comment 23 Victor Ion Munteanu 2014-03-18 18:00:17 EDT
I appologise, I've looked over the sources and saw the blob. I've only fixed the compile errors, didn't bother to look at all the code.

I will try to see if I can contribute directly upstream. In the mean time I believe you can close this.
Comment 24 John Greene 2014-03-19 09:42:02 EDT
I certainly get your frustration: buying the latest and not having out of the box support. I'll continue to monitor this situation and support this as I can.  Will close this for now, but if you decide to contribute please feel free to reopen this or a new issue.  I certainly wish to know!

Arend, as always, thanks for the information and help! Owe you another one.

Note You need to log in before you can comment on or make changes to this bug.